package Visual_DVM_2021.Passes.All;
import _VisualDVM.Global;
import _VisualDVM.GlobalData.RemoteFile.RemoteFile;
import Visual_DVM_2021.Passes.PassCode;
import Common.Passes.PassException;
import Visual_DVM_2021.Passes.SSH.RepositoryServerSSHPass;

import java.io.File;
public class PublishComponentsServer extends RepositoryServerSSHPass {
    @Override
    protected String getServerFileName() {
        return "VisualSapfor.jar";
    }
    @Override
    protected String getServerHomeName() {
        return "_sapfor_x64";
    }
    @Override
    public String getIconPath() {
        return "/icons/Publish.png";
    }
    //1. остановить сервер.
    //2. заменить файл сервера на компонент визуализатора. переименовать его.
    //3. запустить сервер.
    @Override
    protected void ServerAction() throws Exception {
        if ( Global.mainModule.getPass(PassCode.PingComponentsServer).Do(true))
            ShutdownServer();
        if ( Global.mainModule.getPass(PassCode.PingComponentsServer).Do(true)) {
            throw new PassException("Не удалось остановить сервер.");
        }
        File src = Global.visualiser.getFile();
        //-
        RemoteFile dst = new RemoteFile(serverHome, getServerFileName());
        user.connection.tryRM(dst);
        user.connection.putSingleFile(src, dst);
        //-
        StartServer();
    }
    @Override
    protected boolean validate() {

        if (! Global.mainModule.getPass(PassCode.PingComponentsServer).Do(true)) {
            Log.Writeln_("Не удалось запустить сервер.");
        }
        return true;
    }
}

